
# admins sets

set achangelog "arena.changelog"

# admins binds

bind dcc  n nlog                                 mc:admin:nlog
bind dcc  n log                                  mc:admin:log
bind ctcr n ARENA                                mc:admin:chpocknews
bind dcc  - anews                                mc:admin:anews
bind dcc  n roundend                             mc:admin:roundend
bind join n *                                    mc_admin:chpockjoin

bind msg  n !aeq                                 mc:admin:aeq
bind msg  - auth                                 auth:auth
bind msg  - deauth                               auth:deauth
bind sign - *                                    auth:signcheck
bind part - *                                    auth:partcheck

# admins functions

proc mc:admin:log {h idx t} {
  mc:dcclogcmd $h log $t

  if {![isnumber [set t [lindex [split $t] 0]]] || [set t [expr round($t)]] < 1} {
    putidx $idx "Warning: unknown last lines, set as 10.\r"
    set t 10
  }
  set found ""
  foreach lf [logfile] {
    if {[mc:checkin o [lindex $lf 0]]} {
      set found [lindex $lf 2]
      break
    }
  }
  if {$found == ""} {
    putidx $idx "Error: no logfile found.\r"
    return
  }
  set lines 0
  set fid [open $found r]
  while { ![eof $fid] } {
    gets $fid l
    incr lines
  }
  close $fid

  if {$lines <= $t} {
    set needline 1
  } {
    set needline [expr $lines - $t]
  }
  set lines 0
  set fid [open $found r]
  while { ![eof $fid] } {
    gets $fid l
    incr lines
    if {$lines >= $needline} {
      putidx $idx "$l\r"
    }
  }
  close $fid
  putidx $idx "End of log.\r"
}

proc mc:admin:nlog {h idx t} {
  global mc

  mc:dcclogcmd $h nlog $t

  if { ![file exists $mc(file.nlog)] } {
     putidx $idx "nLog is not exist.\r"
     return
  }
  set lastinfo [getuser $h XTRA ARENA_NLOG]
  if {$lastinfo == ""} {
    putidx $idx "Last nLog record for you not found, showing last 10 messages...\r"
    set lines 0
    set fid [open $mc(file.nlog) r]
    while { ![eof $fid] } {
      gets $fid l
      incr lines
    }
    close $fid
    if {$lines < 10} {
      set needline 1
    } {
      set needline [expr $lines - 10]
    }
    set lines 0
    set fid [open $mc(file.nlog) r]
    while { ![eof $fid] } {
      gets $fid l
      incr lines
      if {$lines == $needline} {
        set lastinfo [lindex [split $l] 0]
        break
      }
    }
    close $fid
  } {
    putidx $idx "Last nLog message for you is $lastinfo\r"
  }
  set fid [open $mc(file.nlog) r]
  set lastnp ""
  set found 0
  while { ![eof $fid] } {
    gets $fid l
    if {$l != ""} { set lastnp [lindex [split $l] 0] }
    if {$lastinfo == "" && $l != ""} {
      set dat [lindex [split $lastnp /] 0]
      set tim [join [lrange [split [lindex [split $lastnp /] 1] :] 0 1] :]
      set han [join [lindex [split [lindex [split $l] 1] "#"] 1]]
      set cmm [join [lindex [split $l] 2]]
      set prm [join [lrange [split $l] 3 end]]
      putidx $idx "[cyn]$dat[hblk]/[cyn]$tim[hblk] #[grn]$han[hblk]#[red] $cmm[cl] $prm\r"
      incr found
    } elseif {$lastinfo == [lindex [split $l] 0]} {
      set lastinfo ""
    }
  }
  close $fid
  if {$found == 0} {
    putidx $idx "No new messages for you in nLog.\r"
  } {
    putidx $idx "Total[red] $found[cl] new messages for you.\r"
    setuser $h XTRA ARENA_NLOG $lastnp
  }
}

proc mc_admin:chpockjoin {n uh h c} {
  global achangelog
  if { $h != "Chpock" } { return }

  set lastrec "-"
  if { [file exists $achangelog] } {
    set fid [open $achangelog r]
    while { ![eof $fid] } {
      gets $fid line
      if { [llength $line] > 2 } { set lastrec [lindex $line 0] }
    }
    close $fid
  }

  putquick "PRIVMSG $n :\001ARENA NEWS $lastrec\001"
}

proc mc:admin:chpocknews {n uh h d k t} {
  global achangelog
  if { $h != "Chpock" } { return 1 }
  set t [split $t]
  if { [string tolower [lindex $t 0]] != "news" } { return 1 }

  set fid [open $achangelog a+]
  puts $fid "[lrange $t 1 end] \r"
  close $fid

  putlog "[grn]Added news from[red] $h [grn]dated as[cyn] [string trim [lindex $t 1] \[\]][cl]"
  return 1
}

proc mc:admin:anews {h idx t} {
  global achangelog

  mc:dcclogcmd $h anews $t

  if { ![file exists $achangelog] } {
     putidx $idx "ChangeLog is not exist.\r"
     return
  }
  if { $t == "" } {
    set lastinfo [getuser $h XTRA ARENA_NEWS]
  } {
    set lastinfo ""
  }
  if {$lastinfo == ""} {
    putidx $idx "Last ChangeLog record for you not found, showing last 10 messages...\r"
    set lines 0
    set fid [open $achangelog r]
    while { ![eof $fid] } {
      gets $fid l
      if { $l == "" } { continue }
      incr lines
    }
    close $fid
    if {$lines < 10} {
      set needline 1
    } {
      set needline [expr $lines - 10]
    }
    set lines 0
    set fid [open $achangelog r]
    while { ![eof $fid] } {
      gets $fid l
      if { $l == "" } { continue }
      incr lines
      if {$lines == $needline} {
        set lastinfo [string trim [lindex $l 0] \[\]]
        break
      }
    }
    close $fid
  } {
    putidx $idx "Last ChangeLog message for you is $lastinfo\r"
  }
  set fid [open $achangelog r]
  set lastnp ""
  set found 0
  while { ![eof $fid] } {
    gets $fid l
    if { [llength $l] < 2 } { continue }
    set lastnp [string trim [lindex $l 0] \[\]]
    if {$lastinfo == "" && $l != ""} {
      set dat [lindex [split $lastnp /] 0]
      set tim [lindex [split $lastnp /] 1]
      set dcol "10"
      if { [lindex $l 1] == "\[a\]" } {
        set txt [lrange $l 2 end]
        set dcol "04"
      } elseif { [lindex $l 1] == "\[i\]" } {
        set txt [lrange $l 2 end]
        set dcol "14"
      } {
        set txt [lrange $l 1 end]
      }
      set repl1 ""
      switch -- [lindex $txt 0] {
        "#" { set repl1 "6#" }
        "+" { set repl1 "13+"  }
        "-" { set repl1 "4-"  }
      }
      if { $repl1 != "" } { set txt [lreplace $txt 0 0 $repl1] }

      set inwh [lindex $txt 1]
      if { [string index $inwh 0] == "(" && [string index $inwh end] == ")" } {
        set inwh "14\(03[string trim $inwh \(\)]14\)"
        set txt [lreplace $txt 1 1 $inwh]
      }
      regsub -all "('\[^'\]*')" $txt "[hmag]\\1[cl]" txt
      putidx $idx "$dcol$dat14/$dcol$tim [join $txt]\r"
      incr found
    } elseif {$lastinfo == $lastnp} {
      set lastinfo ""
    }
  }
  close $fid
  if {$found == 0} {
    putidx $idx "No new messages for you in nLog.\r"
  } {
    putidx $idx "Total4 $found new messages for you.\r"
    setuser $h XTRA ARENA_NEWS $lastnp
  }
}

proc mc:admin:roundend {h idx t} {
  putidx $idx "[red]Finish round...[cl]"
  mc:roundend
}

proc mc:admin:aeq {n uh h t} {
  if {![mc:ismaster $h]} { return }
  mc:nlog $h $t

  set uhelp "Usage: !aeq list|add|del|mod <nick> \[args\]"

  set t [split $t]
  if { [llength $t] >= 2 } {
    set id [mc:makeid [lindex $t 1]]
    if { ![mc:userexists $id] } {
      mc:msg $n "   ."
      return
    }
    set ueq [mc:getstat eq $id]
  } {
    mc:msg $n $uhelp
    return
  }


  switch -- [string tolower [lindex $t 0]] {
    "list" {
      if { [llength $t] == 2 } {
        set frm "Items on6 $id14:4 %s"
        set out ""
        set count 0
        foreach item $ueq {
          mc:out $n $frm out [format "%s.10%s14\(03%s14\)" [lindex $item 1] [mc:wget [lindex $item 0] name] [lindex $item 0]] "10,4 "
          incr count
        }
        mc:lastout $n $frm out "10,4 "
        mc:msg $n "Total4 $count10 items at6 $id10."
      } {
        set needitem ""
        foreach item $ueq {
          if { [lindex $item 1] == [lindex $t 2] } {
            set needitem $item
            break
          }
        }
        if { $needitem == "" } {
          mc:msg $n "Item number4 [lindex $t 2]10 is not found at6 $id10."
        } {
          set out ""
          set count 0
          set frm "Item [lindex $t 2].[mc:wget [lindex $needitem 0] name]\([lindex $needitem 0]\) at6 $id10: %s"
          foreach param [lindex $needitem 4] {
            mc:out $n $frm out [format "04%s14\(%s14\)" [lindex $param 0] [lindex $param 1]] "10, "
            incr count
          }
          if { $count != 0 } {
            mc:lastout $n $frm out "10, "
          } {
            mc:msg $n "Item number4 [lindex $t 2]10 at6 $id10 not have any properties."
          }
        }
      }
    }
    "del" {
      if { [llength $t] != 3 } {
        mc:msg $n "Usage: !aeq del <nick> <itemnum>"
        return
      }
      set needitem ""
      set neweq    ""
      foreach item $ueq {
        if { [lindex $item 1] == [lindex $t 2] } {
          set needitem $item
        } {
          lappend neweq $item
        }
      }
      if { $needitem == "" } {
        mc:msg $n "Item number4 [lindex $t 2]10 is not found at6 $id10."
      } {
        mc:setstat eq $id $neweq
        mc:msg $n "Item [lindex $t 2].[mc:wget [lindex $needitem 0] name]\([lindex $needitem 0]\) removed from6 $id10."
      }
    }
    "add" {
      if { [llength $t] != 3 } {
        mc:msg $n "Usage: !aeq add <nick> <itemcode>"
        return
      }
      set iid [string tolower [lindex $t 2]]
      if { ![mc:shop:exist $iid] } {
        mc:msg $n "Bad item code. \($iid\)"
        return
      }

      foreach pp $ueq {
        set tarr([lindex $pp 1]) 1
      }
      set nn 0
      for {set i 0} {$i <= [array size tarr]} {incr i} {
        if {![info exist tarr($i)]} {
          set nn $i
          break
        }
      }
      mc:setstat eq $id [lappend ueq "$iid $nn 0 - {}"]
      mc:wset $nn price $id [mc:wget $iid price]
      mc:sorteq $id
      mc:msg $n "Item $nn.[mc:wget $iid name]\($iid\) is added to6 $id"
    }
    "mod" {
      if { [llength $t] == 2 } {
        mc:admin:aeq $n $uh $h "list [lindex $t 1]"
      } elseif { [llength $t] == 3 } {
        mc:admin:aeq $n $uh $h "list [lindex $t 1] [lindex $t 2]"
      } elseif { [llength $t] == 4 } {
        mc:msg $n "Usage: !aeq mod <nick> <itemnum> <mod> <val>"
      } else {
        set needitem ""
        foreach item $ueq {
          if { [lindex $item 1] == [lindex $t 2] } {
            set needitem $item
            break
          }
        }
        if { $needitem == "" } {
          mc:msg $n "Item number4 [lindex $t 2]10 is not found at6 $id10."
        } {
          mc:wset [lindex $t 2] [lindex $t 3] $id [join [lrange $t 4 end]]
          mc:admin:aeq $n $uh $h "list [lindex $t 1] [lindex $t 2]"
        }
      }
    }
    default {
      mc:msg $n $uhelp
    }
  }

}

proc mc:admin:outcast {n uh h c t} {
    global ct

    set id [mc:makeid [join [lindex [split $t] 1]]]
    set num [join [lindex [split $t] 2]]

    if {![mc:ismaster $h]} { return }
    if { ![mc:userexists $id] } { return }
    if { ![isnumber $num] } {
        set num 5
    } {
        set num [expr round($num)]
        if { $num <= 0 } { set num 5 }
    }

    mc:setstat fmaster $id 0
    mc:setstat outcast $id $num
    mc:findmasters 0
    mc:say [format $ct(outcast) $h [ms:dfl [mc:getstat nick $id]] $num]
}

proc auth:auth {nick uhost hand arg} {
  global botnick
  if {$hand == "*"} {
    notice $nick "Go away!"
    return 0
  }
  set found 0
  foreach n [channels] {
    if {[onchan $nick $n]} {
      set found 1
    }
  }
  if {$found == 0} {return 0}
  if {[llength $arg] <1} {
    notice $nick "Usage: /msg $botnick auth <pass>"
    return 0
  }
  set pass [lindex $arg 0]
  if {[getuser $hand XTRA AUTH] == "DEAD"} {
    notice $nick "Sorry, but you have been disabled from using my commands."
    return 0
  }
  if {[passwdok $hand $pass]} {
    setuser $hand XTRA "AUTH" "1"
    putcmdlog "<<$nick>> ($uhost) !$hand! AUTH ..."
    notice $nick "Authorization successful."
    chattr $hand +Q
    return 0
  } else {
    notice $nick "Access denied."
  }
}

proc auth:signcheck {nick uhost hand chan reason} {
  if {$hand == "*"} {return 0}
  if {[getuser $hand XTRA AUTH] == "DEAD"} { return 0 }
  if { [auth:check $hand] } { putlog "Auto-deauth for \002$hand\002, signed off." }
  setuser $hand XTRA "AUTH" "0"
  chattr $hand -Q
}

proc auth:partcheck {nick uhost hand chan msg} {
  if {$hand == "*"} {return 0}
  if {[getuser $hand XTRA AUTH] == "DEAD"} { return 0 }
  foreach ch [channels] {
    if { ($ch != $chan) && ([onchan $nick $ch]) } { return 0 }
  }
  if { [auth:check $hand] } { putlog "Auto-deauth for \002$hand\002, left all chans." }
  setuser $hand XTRA "AUTH" "0"
  chattr $hand -Q
}

proc auth:check {hand} {
  if { [mc:chkflag debug] } { return 1 }
  set auth [getuser $hand XTRA "AUTH"]
  if {($auth == "") || ($auth == "0") || ($auth == "DEAD")} {
    return 0
  } else {
    return 1
  }
}

proc auth:deauth {nick uhost hand arg} {
  if {[getuser $hand XTRA AUTH] == "DEAD"} {
    notice $nick "Sorry, but you have been disabled from using my commands."
    return 0
  }
  if {$hand != "*"} {
    setuser $hand XTRA "AUTH" "0"
    chattr $hand -Q
    putcmdlog "<<$nick>> ($uhost) !$hand! DEAUTH"
    notice $nick "Authentication has been removed."
  }
}
