
### ---------------------------------------------------------------------------
###     . 
###      ,   ,
###  .

proc mc:affect:globalinit {} {
    global mcaffsys

    if { [info exists mcaffsys] } {
        unset mcaffsys
    }
}

### ---------------------------------------------------------------------------
### /  .

proc mc:affect:setparam {aid param value} {
    global mcaffsys

    set mcaffsys(params.$aid.$param) $value
}

### ---------------------------------------------------------------------------
###    .

proc mc:affect:getparam {aid param} {
    global mcaffsys

    if { ![info exists mcaffsys(params.$aid.$param)] } {
        return -1
    }

    return $mcaffsys(params.$aid.$param)
}

### ---------------------------------------------------------------------------
### ---------------------------------------------------------------------------
### ---------------------------------------------------------------------------

### ---------------------------------------------------------------------------
###   .

proc mc:affect:init {} {
    global mcaffects

    if { [info exists mcaffects] } {
        unset mcaffects
    }
}

### ---------------------------------------------------------------------------
###   .      .
###
### :
### 1 -  .
### 2 -  .
###(3)-     . [ 0/... ]
###(4)-   .
###(5)-    . [ 0/1/2 ]
###     0 -   .
###     1 -    .
###     2 -      .
###
###  :
### 0 -     
### 1 -      
### 2 -     ().

proc mc:affect:add {aid victim {duration 0} {power 1} {powerflag 2}} {
    global mcaffects

    if { ![info exists mcaffects($victim)] } {
        lappend mcaffects($victim) $aid $duration $power
        return 1
    }

    set i 0
    foreach affect $mcaffects($victim) {
        if { [lindex $affect 0] == $aid } {
            if { $powerflag == 1 || ($powerflag == 2 && [isrealnumber $power] && \
                 [isrealnumber [lindex $affect 1]] && $power > [lindex $affect 1]) \
            } {
                ###          .
                set mcaffects($victim) [lreplace $mcaffects($victim) $i $i]
                lappend mcaffects($victim) $aid $duration $power
                return 2
            } else {
                return 0
            }
        }
        incr i
    }

    lappend mcaffects($victim) $aid $duration $power
    return 1
}

### ---------------------------------------------------------------------------
###     .
###
### :
### 1 -  .
### 2 - id .
###
###  :
### 0 -     , ..     .
### 1 -      .

proc mc:affect:del {aid victim} {
    global mcaffects

    if { ![info exists mcaffects($victim)] } {
        return 0
    }

    set i 0
    foreach affect $mcaffects($victim) {
        if { [lindex $affect 0] == $aid } {
            set mcaffects($victim) [lreplace $mcaffects($victim) $i $i]
            return 1
        }
        incr i
    }

    return 0
}

### ---------------------------------------------------------------------------
###   .     ,   .
###
### :
### 1 -  .
### 2 - id .
###(3)-   .
###
###  :
### ,   .      , 
###  -1.

proc mc:affect:power {aid victim {newpower ""}} {
    global mcaffects

    if { ![info exists mcaffects($victim)] } {
        return -1
    }

    set i 0
    foreach affect $mcaffects($victim) {
        if { [lindex $affect 0] == $aid } {
            if { $newpower != "" } {
                set mcaffects($victim) [lreplace $mcaffects($victim) $i $i [lreplace $affect 2 2 $newpower]]
                return $newpower
            } else {
                return [lindex $affect 2]
            }
        }
        incr i
    }

    return -1
}

### ---------------------------------------------------------------------------
###   .     , 
###  .
###
### :
### 1 -  .
### 2 - id .
###(3)-     .
###
###  :
### ,   .      ,
###   -1.

proc mc:affect:duration {aid victim {newduration ""}} {
    global mcaffects

    if { ![info exists mcaffects($victim)] } {
        return -1
    }

    set i 0
    foreach affect $mcaffects($victim) {
        if { [lindex $affect 0] == $aid } {
            if { $newduration != "" } {
                set mcaffects($victim) [lreplace $mcaffects($victim) $i $i [lreplace $affect 1 1 $newduration]]
                return $newpower
            } else {
                return [lindex $affect 1]
            }
        }
        incr i
    }

    return -1
}

### ---------------------------------------------------------------------------
###      1 .  
###     ,    
### .
###
### :
### 1 -  .
### 2 - id .
###
###  :
### -2 -      .
### -1 -   .
###    .

proc mc:affect:cycle {aid victim} {
    global mcaffects

    if { ![info exists mcaffects($victim)] } {
        return -2
    }

    set i 0
    foreach affect $mcaffects($victim) {
        if { [lindex $affect 0] == $aid } {
            set duration [lindex $affect 1]
            if { $duration > 0 } {
                incr duration -1
                set mcaffects($victim) [lreplace $mcaffects($victim) $i $i [lreplace $affect 1 1 $duration]]
                return $duration
            } else {
                return -1
            }
        }
        incr i
    }

    return -2
}

### ---------------------------------------------------------------------------
###      .     
###     !affects, .
###
### :
### 1 - id .
###
###  :
###      ,  "".

proc mc:affect:list {victim} {
    global mcaffects

    if { ![info exists mcaffects($victim)] } {
        return ""
    }

    set list ""
    foreach affect $mcaffects($victim) {
        lappend list [lindex $affect 0]
    }

    return $list
}
