
###       <fl>
proc mc:chkflag {fl} {
  global mc
  if {![info exist mc($fl)] || !$mc($fl)} { return 0 } { return 1}
}

###  
proc mc:config:setver {ver} {
  global mc
  set mc(ver) $ver
  mc:config:save
}


###    
### args - 
### tp -  
###   bool :  <0/1>
###   int  :  
###   str  : 
###   float: 
###       <!>    (   .conf)

proc mc:config:register {param tp default {args ""}} {
   global mc

   if {![info exist mc($param)]} { set mc($param) $default }
   if {![info exist mc(config)]} { set mc(config) "" }
   if {[llength $args]==1 && [lindex [lindex $args 0] 0]=="%"} {
      set args [lreplace [lindex $args 0] 0 0]
   }

   set out ""
   foreach cf $mc(config) {
     if {[join [lindex $cf 0]]==$param} { continue }
     lappend out $cf
   }
   lappend out "{[split $param]} $tp {[split $default]} {$args}"
   set mc(config) $out
}

proc mc:config:list {h idx t} {
  global mc col

  if {$t==""} {
    set t "*"
  } {
    if { [llength [split $t]] > 1 } {
      mc:config:set $h $idx $t
      return
    }
    set t "[split $t]*"
  }

  mc:dcclogcmd $h conf $t
  set frm0 "$col(hgrn).-$col(hblk)\[$col(cl)Mask: $t$col(hblk)\]$col(hgrn)---$col(grn)--$col(hblk)-- -"
  set frm1 "$col(hgrn)|$col(cl) %-20s$col(hblk) : %s$col(cl)"
  set frm2 "$col(hgrn)`---$col(hblk)\[$col(cl)Total: %s$col(hblk)\]$col(hgrn)-----$col(grn)--$col(hgrn)--$col(grn)----$col(hblk)-$col(grn)--$col(hblk)-- - :: -$col(cl)"
  set frm3 "No variable found on mask <$t>."

  set i 0
  foreach cf $mc(config) {
     set prm [join [lindex $cf 0]]
     if {![string match -nocase $t $prm]} { continue }
     if {[string index [lindex $cf 1] 0]=="!"} { continue }
     switch -- [lindex $cf 1] {
       bool { if {$mc($prm)} {set ret "$col(hcyn)on" } { set ret "$col(cyn)off" } }
       int { set ret "$col(hgrn)$mc($prm)" }
       float { set ret "$col(hmag)$mc($prm)" }
       default { if {$mc($prm)==""} { set ret "$col(hblk)<null>" } { set ret "$col(cl)$mc($prm)" } }
     }
     if {!$i} { putidx $idx "$frm0\r" }
     putidx $idx "[mc:strongspace [format $frm1 $prm $ret]]\r"
     incr i
  }
  if {$i} {
    putidx $idx "[mc:strongspace [format $frm2 $i]]\r"
  } {
    putidx $idx "$frm3\r"
  }
}

proc mc:config:set {h idx t} {
  global mc col

  mc:dcclogcmd $h confset $t
  if {$t==""} {
    putidx $idx "Usage: confset <variable> \[<param>\] \(to clear value set <param> to \"-\"\)\r"
    return
  }

  set varn [string tolower [join [lindex [split $t] 0]]]
  set varp [join [lrange [split $t] 1 end]]
  foreach cf $mc(config) {
     set prm [join [lindex $cf 0]]
     if {$prm==$varn} {
       if {$varp!=""} {
         if {$varp=="-"} { set varp "" }
         switch -- [lindex $cf 1] {
           bool {
             set varp [string tolower $varp]
             if {$varp=="on" || $varp=="1" || $varp=="yes"} { set mc($prm) 1
             } elseif {$varp=="off" || $varp=="0" || $varp=="no"} { set mc($prm) 0
             } else {
               putidx $idx "$col(red)Warning!$col(cl) Variable$col(grn)\[$col(cl)$prm$col(grn)\]$col(cl) is boolean. \(Value must be $col(cyn)on$col(cl) or $col(cyn)off$col(cl)\)\r"
             }
           }
           int {
             if {[isnumber $varp]} {
               set mc($prm) $varp
             } else {
               putidx $idx "$col(red)Warning!$col(cl) Variable$col(grn)\[$col(cl)$prm$col(grn)\]$col(cl) is integer. \(Value must be number\)\r"
             }
           }
           float {
             if {[isrealnumber $varp]} {
               set mc($prm) $varp
             } else {
               putidx $idx "$col(red)Warning!$col(cl) Variable$col(grn)\[$col(cl)$prm$col(grn)\]$col(cl) is float. \(Value must be number\)\r"
             }
           }
           default { set mc($prm) $varp }
         }
         mc:config:save
       }
       switch -- [lindex $cf 1] {
         bool { if {$mc($prm)} {set ret "$col(hcyn)on" } { set ret "$col(cyn)off" } }
         int { set ret "$col(hgrn)$mc($prm)" }
         float { set ret "$col(hmag)$mc($prm)" }
         default { if {$mc($prm)==""} { set ret "$col(hblk)<null>" } { set ret "$col(cl)$mc($prm)" } }
       }
       putidx $idx "Value$col(grn)\[$col(cl)$prm$col(grn)\]$col(hblk) ==$col(cl) $ret$col(cl)\r"
       return
     }
  }
  putidx $idx "Variable$col(grn)\[$col(cl)$varn$col(grn)\]$col(cl) not found.\r"
}

proc mc:config:help {h idx t} {
  global mc col

  if {$t==""} { set t "*" } { set t "[split $t]*" }

  mc:dcclogcmd $h confhelp $t
  set frm0 "$col(hgrn).-$col(hblk)\[$col(cl)Mask: $t$col(hblk)\]$col(hgrn)---$col(grn)--$col(hblk)-- -"
  set frm1 "$col(hgrn)|$col(cl) %-15s$col(hblk) :$col(cl) %s $col(hblk)\($col(cl)%s$col(hblk)\)$col(cl)"
  set frm2 "$col(hgrn)`---$col(hblk)\[$col(cl)Total: %s$col(hblk)\]$col(hgrn)-----$col(grn)--$col(hgrn)--$col(grn)----$col(hblk)-$col(grn)--$col(hblk)-- - :: -$col(cl)"
  set frm3 "No variable found on mask <$t>."

  set i 0
  foreach cf $mc(config) {
     set prm [join [lindex $cf 0]]
     if {![string match -nocase $t $prm]} { continue }
     if {[string index [lindex $cf 1] 0]=="!"} { continue }
     switch -- [lindex $cf 1] {
       bool { if {$mc($prm)} {set ret "$col(hcyn)on" } { set ret "$col(cyn)off" } }
       int { set ret "$col(hgrn)$mc($prm)" }
       float { set ret "$col(hmag)$mc($prm)" }
       default { if {$mc($prm)==""} { set ret "$col(hblk)<null>" } { set ret "$col(cl)$mc($prm)" } }
     }
     if {!$i} { putidx $idx "$frm0\r" }
     putidx $idx "[mc:strongspace [format $frm1 $prm [join [lindex $cf 3]] [lindex $cf 1]]]\r"
     incr i
  }
  if {$i} {
    putidx $idx "[mc:strongspace [format $frm2 $i]]\r"
  } {
    putidx $idx "$frm3\r"
  }
}

proc mc:config:save {} {
  global mc
  set fid [open $mc(file.conf) w]
  foreach cf $mc(config) {
    set out $cf
    lappend out $mc([join [lindex $cf 0]])
    puts $fid "$out\r"
  }
  close $fid
}

proc mc:config:load {} {
  global mc

  putlog "Loading bot-specific config..."
  set exconf ""
  if {[array exist mc] && [info exist mc(config)]} {
    foreach cf $mc(config) { lappend exconf [lindex $cf 0] }
  }

  if {[file exists $mc(file.conf)]} {
    set fid [open $mc(file.conf) r]
    while {![eof $fid]} {
      gets $fid line
      set prm [join [lindex $line 0]]
      if {[llength $line]==5} {
        if {[lsearch -exact $exconf $prm]==-1} {
          mc:config:register [join [lindex $line 0]] [lindex $line 1] [join [lindex $line 2]] "% [lindex $line 3]"
        }
        set mc($prm) [lindex $line 4]
      }
    }
    close $fid
  }
}

proc mc:config:autosave {mi ho da mo ye} { mc:config:save }
bind time - "?0 * * * *" mc:config:autosave
