
proc mc:reg:getstat {stt id} {
  global mcr mcc

  switch -- $stt {
    comnum  { return $mcr($id) }
    comtxt  { return $mcc($mcr($id)) }
    isnocom {
      if {[string range $mcc($mcr($id)) 0 3] == "@nc-"} { return 1 }
      return 0
    }
    noname  {
      if { [string range $mcc($id) 0 3] == "@nc-" } { return 1 }
      return 0
    }
    default {
      putlog "!Error! reg:getstat $stt $id"
      return 0
    }
  }
}

proc mc:minvite {n uh h t} {
  global mc ct

  set id [mc:makeid $n]
  if {![mc:check $id -]} { return }

  if { [info exist mc(inv.list)] } {
    if { [lsearch -exact $mc(inv.list) $id] != -1 } { return }
  } {
    set mc(inv.list) ""
  }

  lappend mc(inv.list) [split $n]
  mc:msg $n $ct(invi)
}

proc mc:phalt {n uh h c t} {
  global ct mc

  cleartimers
  set mc(phase) -1
  mc:say $ct(halt)
  mcu:checkmoderate
}

proc mc:plimit {n uh h c t} {
    global mcs mc ct mcr mcc mce alreadylimit

    if { [llength $t] > 1 } {
        set ll [lindex [ms:fl $t] 1]
        if { [isnumber $ll] } {
            set mc(limit) $ll
            ###       
            set alreadylimit 0
        }
    }
    mc:tsay $n [format $ct(11b) $mc(limit)]
}

proc mc:palevel {n uh h c t} {
    global mcs mc ct

    if {[llength $t] > 1} {
        set ll [lindex [ms:fl $t] 1]
        if {[isnumber $ll] || $ll == "-1"} {
            set mc(alevel) $ll
        }
    }
    mc:tsay $n [format $ct(11c) $mc(alevel)]
}

proc mc:startreg {} {
    global mc ct noreg alreadylimit
    global mcr mce mcc todo oldtodo ghost killed mcch regcontrol completeready alreadysleep

    if { ![mc:mode:isdisable invite] } {
      foreach nick [chanlist $mc(chan)] {
        set id [mc:makeid $nick]
        if { ![mc:check $id -] } continue
        if { ![mc:modeok $id "invite"] } continue
        if { [info exist mc(inv.list)] } {
        if { [lsearch -exact $mc(inv.list) $nick] != -1 } continue
        } {
          set mc(inv.list) ""
        }
        lappend mc(inv.list) $id
      }
    }


    if {[info exist mc(inv.list)]} {
      set onick ""
      foreach id $mc(inv.list) {
        if { ![onchan [ms:dfl $id] $mc(chan)] } { continue }
        lappend onick $id
      }
      if { $onick != "" } {
        putlog "[grn]Send Invite[hblk]:[cl] $onick"
        mc:_massmsg $onick "{[format $ct(invi.text) $mc(chan)]}" 1
      }
      unset mc(inv.list)
    }


    if { [mc:isbot public] } { return }

    set mc(phase) 0
    ###    
    if { [info exist mcr] }        { unset mcr        }
    if { [info exist mce] }        { unset mce        }
    if { [info exist mcc] }        { unset mcc        }
    if { [info exist todo] }       { unset todo       }
    if { [info exist oldtodo] }    { unset oldtodo    }
    if { [info exist ghost] }      { unset ghost      }
    if { [info exist killed] }     { unset killed     }
    if { [info exist mcch] }       { unset mcch       }
    if { [info exist regcontrol] } { unset regcontrol }
    if { [info exist completeready] } { unset completeready }
    if { [info exist alreadysleep]  } { unset alreadysleep  }

    ###    
    set maxsize $mc(averagelevel)
    if {$mc(alevel) >= 0} { set maxsize $mc(alevel) }

    set rand [rand 3]
    set out [mc:randchars "$ct(reg$rand)"]
    if {!$mc(nocom)} {
      set out "$out [mc:randchars [format $ct(regs) $maxsize]]"
      set lout "[cyn]MaxSize:[red] $maxsize"
    } else {
      set out "$out $ct(rega)"
      set lout "[yel]no commands"
    }
    putlog "[red]REGSTART[hblk] \($lout[hblk]\)[cl]"
    mc:say $out
    set noreg 0
    cleartimers
    utimer 4 {
        if {$mc(moderating) == 1 && [mc:moderated]} {
            pushmode $mc(chan) -m
        }
    }

    ###       
    set alreadylimit 0
}

proc mc:pstartreg {n uh h c t} {
    global mc ct noreg

    cleartimers
    mc:startreg
}

proc mc:preguser {n uh h c t} {
    global mc mcs

    if { [llength $t] < 2 } { return }

    set id [lindex $t 1]
    set param [lrange $t 2 end]

    if { ![info exists mcs([mc:makeid $id])] } { return }

    mc:preg $id $uh $h $c "!reg $param" $id
}

proc mc:preg {n uh h c t {nk ""}} {
    global mcs mc ct cto ctho mcr mcc mce noreg mco mctn prof race mcch mchost countr
    global alrdsay alreadylimit alreadysleep completeready
    global regcontrol
    global killed ghost liv todo
    global botnick

    if { [string tolower [lindex [split $t] 0]] == "!reguser" } { return }
    if { $mc(phase) == -1 } { return }
    if { $noreg == 1 && $nk == "" } {
        return
    }
    if { $nk == "" } {
        set id [mc:makeid $n]
    } else {
        set id [mc:makeid $nk]
    }

    if {![info exists mcs($id)]} { return }
    if { [info exists alreadysleep($id)] && $alreadysleep($id) == 1 }   { putlog "NOREG $id: alreadysleep"; return }
    if { [info exists completeready($id)] && $completeready($id) == 1 } { putlog "NOREG $id: completeready"; return }
    if { $mc(phase) > 0 && [llength $t] == 1 && $mc(regkicks) == 1 && $countr > 0 && $nk == "" } {
      if { ![info exists regcontrol($id)] } { set regcontrol($id) 1 }
      putlog "regcontrol([ms:dfl $id]) :: $regcontrol($id)"
      if { $regcontrol($id) >= 3 } {
        set bhost "$n!*"
        regsub -all "\[~\]" $bhost "" bhost
        if { ![isban $bhost $mc(chan)] } {
          unset regcontrol($id)

          putlog "Reg ban mask :: $bhost"
          newchanban $mc(chan) $bhost $botnick "The maniac of registration (15 minutes)" 15
          putserv "KICK $mc(chan) $n :The maniac of registration (15 minutes)"

          ###     
          if { [info exists mcr($id)] } {
            set killed($toid) 1
            if { [string first "run" $todo($id)] == -1 } {
              lappend todo($id) "run"
            }
            if { [info exist ghost($id)] } { unset ghost($id) }
          }
        }
      } else {
        incr regcontrol($id)
        putkick $mc(chan) $n "Arena already combats, sit quietly, please \[WBR\]"
      }
      return
    }

    if { ![info exists mcs($id)] && $mc(phase) == 0 } {
        mc:tsay $n $ct(10)
        return
    }
    if {[info exist mc(maxlvl)]} {
      set rmt [mc:getstat remort $id]
      ###    .    
      if {[expr [llength $mc(maxlvl)] - 1]<$rmt} { return }
      ###   
      if {[mc:getstat level $id]>[lindex $mc(maxlvl) $rmt]} { return }
    }

    if { [mc:getstat pass $id] == "-disable-" } {
        mc:notice [mc:getstat nick $id] $ct(0f)
        return
    }
    if { [mc:getstat pass $id] == "-nopass-" && $nk == "" } {
        mc:notice [mc:getstat nick $id] $ct(0e)
        return
    }
    if {[string index [mc:getstat pass $id] 0]=="-"} { return }

    if { ![mc:check $id 0] && $nk == "" } { return }

    ###    
    set maxsize $mc(averagelevel)
    if { $mc(alevel) >= 0 } { set maxsize $mc(alevel) }

    ###  maxsize'   
    if { [mc:getstat remort $id] < [llength $mc(overlimit)] && [mc:getstat level $id] <= [lindex $mc(overlimit) [mc:getstat remort $id]]} {
      set maxsize 999
    }

    set ondcc 0
    foreach nn [array names mctn] {
        if {$mctn($nn) == $id} {
            set ondcc 1
            break
        }
    }

    set mcrstr ""
    set mctnstr ""
    foreach idr [array names mcr] { set mcrstr "$mcrstr $idr" }
    foreach idr [array names mctn] { set mctnstr "$mctnstr $idr" }

    ###     ,    
    ### ,    ! <>  ,     
    if { [array exists mcch] && [info exists mcch($id)] } { unset mcch($id) }



    ###     ' '
    if { $mc(nocom) || [mc:getstat outcast $id] > 0 || ([llength $t] == 1 && ([mc:getstat com $id] == "-" || ![mc:com:exist [mc:comid [mc:getstat com $id]]])) || [lindex $t 1] == "-" } {
      set fnocom 1
    } {
      set fnocom 0
    }

    if { [array exists mcr] && [info exists mcr($id)] && ([llength $t] == 1 || $mc(nocom))} {
###        
      return
    } elseif { [array exists mcr] && [info exist mcr($id)] } {
###          
        unset mcr($id)
        unset mce($id)
        if { [array size mcr] == 0 } {
            unset mcr
            unset mce
            unset mcc
        } else {
            foreach e [array names mcr] {
                set ttmm($mcr($e)) 1
            }
            foreach e [array names mcc] {
                if { ![info exists ttmm($e)] } {
                    unset mcc($e)
                }
            }
        }
    } elseif { $nk == "" && [array exist mcr] && [array size mcr] >= $mc(limit) } {
###   
      return
    }

    cleartimers

###             
    if {[array exists mcc]} {
        set maxcom 1
        foreach nn [array names mcc] {
            if {[expr $nn + 1] > $maxcom} { set maxcom [expr $nn + 2] }
        }
        set mostcom 1
        for {set i 1} {$i <= $maxcom} {incr i} {
            if {![info exist mcc($i)]} {
                set mostcom $i
                break
            }
        }
    } else {
        set maxcom 1
        set mostcom 1
    }

    if { $fnocom } {
        set regcom $mostcom
    } elseif { [llength $t] == 1 } {
        set regcom $mostcom
        if { [array exists mcc] } {
            foreach e [array names mcc] {
                if {[mc:tolat [mc:comid [mc:getstat com $id]]] == [mc:tolat [mc:comid $mcc($e)]]} {
                    set regcom $e
                    break
                }
            }
        }
    } else {
        set tmpcom [lindex $t 1]
        if { [isnumber $tmpcom] } { set tmpcom [expr round($tmpcom)] }
        if { ![isnumber $tmpcom] || $tmpcom > $maxcom || $tmpcom < 1 || $mc(gametype) == 2 } {
          mc:tsay $n $ct(12)
          return
        } elseif { [array exist mcc] && [info exist mcc($tmpcom)] && [string range $mcc($tmpcom) 0 3] == "@nc-" } {
          mc:tsay $n $ct(12)
          return
        }
        set regcom $tmpcom
    }

###     
    set toreg ""
    if {!$fnocom && [array exist mcc] && [info exist mcc($regcom)] } {
        set toreg $mcc($regcom)
    } elseif {!$fnocom && [mc:getstat com $id] != "-"} {
        set toreg [mc:getstat com $id]
    }

    if { $toreg != "" && [info exist mco([mc:comid $toreg])] } {
        set cid [mc:comid $toreg]
        set ac [mc:comga $cid $id]
#        if { ([mc:mcomget $cid 4] == 1 && $ac < 1) || $ac < 0 }
# ^     pub-   ....
        if { $ac < 1 } {
            mc:tsay $n [format $cto(0a) [mc:delcom [ms:dfl [mc:mcomget $cid 0]]]]
            unset toreg
            mc:regtimers
            return
        }
    }

    if { ![array exists mcc] || ![info exists mcc($regcom)] } {
      if { $fnocom || [set tmc [mc:getstat com $id]] == "-" } {
        set mcc($regcom) "@nc-$regcom"
        set fnocom 1
      } {
        if { [info exist mco([mc:comid $tmc])] } {
          set tmc [mc:mcomget [mc:comid $tmc] 0]
          set mcc($regcom) $tmc
          foreach e [array names mcc] {
            if { $e != $regcom && [mc:tolat [mc:comid $mcc($e)]] == [mc:tolat [mc:comid $mcc($regcom)]] } {
              set mcc($regcom) ".$regcom"
              set mcc($regcom) "@nc-$regcom"
              set fnocom 1
              break
            }
          }
        } {
          set mcc($regcom) "@nc-$regcom"
          set fnocom 1
        }
      }
    }


    ### -=-=-=- <   > -=-=-=-
    set found 1
    set may 1
    set num 0
    if { [array exists mchost] } {
        foreach host [array names mchost] {
            if {[string match [lindex $mchost($host) 0] $uh]} {
                set num $host
                break
            }
        }
    }
    if { $num != 0 } { set may [lindex $mchost($num) 1] }
    set mask "*[string range $uh [string first "@" $uh] end]"

    if { [array exists mcch] } {
        foreach addr [array names mcch] {
            if { [string match $mask $mcch($addr)] } {
                incr found
            }
        }
    }

    if { $nk == "" && $found > $may } {
        mc:tsay $n [xformat3 $ctho(reg) {} $may]
        if {[info exists mcr($id)]} { unset mcr($id) }
        if {[info exists mce($id)]} { unset mce($id) }
        foreach e [array names mcr] {
            set reggedteams($mcr($e)) 1
        }
        foreach e [array names mcc] {
            if {![info exists reggedteams($e)]} { unset mcc($e) }
        }
        mc:pushmode $mc(chan) -v $n
        return
    }
    ### -=-=-=- </   /> -=-=-=-

    ###   
    if { $maxsize > 0 && $nk == "" } {
        set count 1
        foreach x [array names mcr] {
            if { $regcom == $mcr($x) } {
                incr count
            }
        }
        if { $count > $maxsize } {
            mc:say [format $cto(0c) [ms:dfl [mc:getstat nick $id]] [mc:delcom [ms:dfl $mcc($regcom)]] $maxsize]

            set number 1
            foreach e [array names mcc] {
                if {$e > $number} { set number $e }
            }
            incr number
            set regcom $number
#            set mcc($regcom) ".$number"
            set mcc($regcom) "@nc-$regcom"
        }
    }

    set mcr($id) $regcom
    set mce($id) 0
    if { $mc(gametype) == 2 || $mc(nocom) == 0 } {
        set mce($id) 1
    }
    ###    
    set mcch($id) $uh
    mc:pushmode $mc(chan) +v $n

    mc:logn [ms:dfl [mc:getstat nick $id]] "Registered to combat \[[array size mcr]/$mc(limit)\]"

    set output ""

    ### 
    if { $mc(sptitles) > 0 && [mc:getstat ptitle $id] != "" && [mc:getstat remort $id] >= [expr ($mc(sptitles) - 1) / 10] && [mc:getstat level $id] >= [expr $mc(sptitles) % 10] } {
        set output "$output10[mc:getstat ptitle $id]"
    }
    set output "$output12[ms:dfl [mc:getstat nick $id]]"

    ### 
    if { $mc(stitles) > 0 && [mc:getstat title $id] != "" && [mc:getstat remort $id] >= [expr ($mc(stitles) - 1) / 10] && [mc:getstat level $id] >= [expr $mc(stitles) % 10] } {
        set output "$output10[mc:getstat title $id]"
    }
    set output "$output 14\("

    ###     regstr,   ,   
    if { [mc:getstat regstr $id] != "" } {
        set output "[mc:getstat regstr $id]14\("
    }

    ### /
    if { $mc(sraces) > 0 && [mc:getstat trace $id] != "" && [mc:getstat remort $id] >= [expr ($mc(sraces) - 1) / 10] && [mc:getstat level $id] >= [expr $mc(sraces) % 10] } {
        set output "$output[mc:getstat trace $id]"
    } else {
      set minittl "10"
      if { [mc:getstat outcast $id] > 0 } {
        set minittl $ct(out)
      } elseif { [mc:chkflag masters] && [mc:getstat fmaster $id] == 10} {
        set minittl $ct(mast)
      }
      append output [format $ct(reg.str) $minittl [mc:getstat prof $id txt] [mc:getstat race $id txt]]
    }

    if { [mc:getstat remort $id] == 0 } {
        set output [xformat3 $ct(14a) "[mc:getstat sex $id]" $output [mc:getstat level $id]]
    } else {
        set output [xformat3 $ct(14r) "[mc:getstat sex $id]" $output [mc:getstat remort $id] [mc:getstat level $id]]
    }

    if {$fnocom} {
      set output "$output$ct(14f)"
    } else {
      set output "$output[format $ct(14e) [mc:delcom [ms:dfl $mcc($regcom)]] $regcom]"
    }

    set limit 10
    if { [info exists mc(bot.public)] && $mc(bot.public) != "" && [islinked $mc(bot.public)] } {
        set limit 25
    }

    if { [queuesize] <= $limit } {
        mc:say $output
    }

    set mcrstr ""
    set mctnstr ""
    foreach idr [array names mcr]  { set mcrstr  "$mcrstr $idr"  }
    foreach idr [array names mctn] { set mctnstr "$mctnstr $idr" }

    if { [array size mcr] >= $mc(limit) && (![info exists alreadylimit] || $alreadylimit == 0) && $nk == "" } {
        mc:say [format $ct(11a) $mc(limit)]
        set alreadylimit 1
    }

    if {$mc(phase) == 0} { cleartimers }

    if { [mc:modeok $id "auto-ready"] || $nk != "" } {
        set mce($id) 1
        set alrdsay 0
       # mc:checkready
        if { [array size mcc] > 1 } {
            utimer $mc(killregsleep) { mc:killregsleep }
            mc:checkcomm
        }
    }

    if { $mc(phase) > 0 && ![info exist liv($id)] && $nk != "" } {
       mc:setuser $id
       mc:createlist
    }
}

proc mc:regtimers {} {
    global mc mcr mcc mce

    if { [info exists mcc] && [array size mcc] > 2 } {
        utimer $mc(killregsleep) { mc:killregsleep }
        mc:checkcomm
    }
}


proc mc:punreg {n uh h c t} {
    global mcs mc ct mcr mcc mce alreadylimit

    if { $mc(phase) != 0 } { return }

    set id [mc:makeid $n]

   # if { ![info exists mcs($id)] } {
   #     mc:tsay $n $ct(10)
   #     return
   # }
    if { [array exists mcr] && [info exists mcr($id)] } {
        if {[mc:reg:getstat isnocom $id]} {
          mc:tsay $n $ct(14.)
        } else {
          mc:tsay [ms:dfl [mc:getstat nick $id]] [format $ct(14) [mc:delcom [ms:dfl $mcc($mcr($id))]]]
        }
        mc:pushmode $mc(chan) -v $n
        unset mcr($id)
        unset mce($id)
        if {[array size mcr] == 0} {
            unset mcr
            unset mce
            unset mcc
        } else {
            foreach e [array names mcr] {
                set ttmm($mcr($e)) 1
            }
            foreach e [array names mcc] {
                if {![info exists ttmm($e)]} {
                    unset mcc($e)
                }
            }
        }
    }

    ###       
    set alreadylimit 0
}

proc mc:pcom {n uh h c t} {
    global mcs mc ct mcr mcc mce prc lastcom liv

    set info(-) 0
    set pl ""
    if { $mc(phase) == 0 && [array exist mcr]} {
      foreach id [array names mcr] {
        lappend pl $id
        set info($id) $mce($id)
      }
      set frm $ct(com0)
      set apx 1
    } elseif { $mc(phase) == 1 && [array exist liv] } {
      foreach id [array names liv] {
        lappend pl $id
        if { $prc($id) == 0 } { set info($id) 1 } { set info($id) 0 }
      }
      set frm $ct(com2)
      set apx 2
    } else {
        return
    }

    if {[info exist lastcom] && $lastcom > [clock seconds]} { return }
    set lastcom [expr [clock seconds] + $mc(lastcom$apx)]

    if {$pl != ""} {
      mc:excom $pl [array get info] $frm
    } {
      mc:say $ct(16)
    }
}

proc mc:excom {pl ainfo frm} {
  global mcs mc ct mcr mcc mce lastcom
  array set info $ainfo

  set idnocom ""
  foreach e $pl {
    set tmpnick [mc:nohighlight [mc:getstat nick $e]]
    if { $info($e) } { set tmpnick "$tmpnick" }
    if { [mc:reg:getstat isnocom $e] } {
      lappend idnocom $tmpnick
    } else {
      array_check ttmm $mcr($e) ""
      lappend ttmm($mcr($e)) $tmpnick
    }
  }

  set out ""
  foreach e [lsort -integer [array names ttmm]] {
    set nextteam [ms:dfl [join $ttmm($e) $ct(comn)]]
    set nexttname [mc:delcom [ms:dfl $mcc($e)]]
    mc:out - $ct(coma) out [format $frm $e $nexttname $nextteam] $ct(com1)
  }
  mc:lastout - $ct(coma) out $ct(com1)

  set out ""
  foreach id $idnocom {
    mc:out - $ct(comc) out [ms:dfl $id] $ct(comn)
  }
  mc:lastout - $ct(comc) out $ct(comn)
}

proc mc:pmoves {n uh h c t} {
    global mcs mc ct mcr mcc mce lastmoves liv prc

    set pl ""
    set mv 0
    if { $mc(phase) == 0 && [info exist mcr] && [array size mcr] > 0 } {
      set mv  1
      set apx 1
      set frm $ct(52a)
      foreach id [array names mcr] {
        if { $mce($id) } { continue }
        lappend pl $id
      }
    } elseif { $mc(phase) == 1 && [info exist liv] && [array size liv] > 0} {
      set mv  1
      set apx 2
      set frm $ct(52c)
      foreach id [array names liv] {
        if { $prc($id) == 0 } { continue }
        lappend pl $id
      }
    } else {
        return
    }

    if {[info exist lastmoves] && $lastmoves > [clock seconds]} { return }
    set lastmoves [expr [clock seconds] + $mc(lastmoves$apx)]

    if { !$mv } {
      mc:tsay $n $ct(16)
    } elseif { $pl == "" && $mc(phase) == 0 } {
      mc:tsay $n "10    ."
    } elseif { $pl != "" } {
      set out ""
      foreach id $pl {
        mc:out - $frm out [ms:dfl [mc:getstat nick $id]] $ct(52b)
      }
      mc:lastout - $frm out $ct(52b)
    }
}

proc mc:pname {n uh h c t} {
    global mcs mc ct cto mcr mcc mce mco

    set id [mc:makeid $n]
    if { ![mc:check $id 0] } { return }
    if { [mc:reg:getstat isnocom $id] } { return }
    if { [llength $t] < 2 } { return }
    if { $mc(gametype) == 2 } { return }

    set cid [mc:comid [lrange $t 1 end]]
    set tcomm [mc:delcom [lrange [ms:fl $t] 1 end]]
    set officialname ""

    if { [info exist mco($cid)] } {
        set ac [mc:comga $cid $id]
        if {([mc:mcomget $cid 4] == 1 && $ac < 1) || $ac < 0} {
            mc:tsay $n [format $cto(0a) [mc:delcom [ms:dfl [mc:mcomget $cid 0]]]]
            return
        }
        set officialname [mc:delcom [ms:dfl [mc:mcomget $cid 0]]]
    }

    if { [array exists mcr] && [info exists mcr($id)] } {
        foreach e [array names mcc] {
            if { $e != $mcr($id) && [mc:comid $mcc($e)] == $cid } {
                mc:tsay $n $cto(0b)
                return
            }
        }
        if { $officialname != "" } { set tcomm $officialname }

        mc:say [format $ct(13a) $mcr($id) [mc:delcom [ms:dfl $mcc($mcr($id))]] [ms:dfl $tcomm]]

        set mcc($mcr($id)) $tcomm
    } else {
        mc:tsay [ms:dfl [mc:getstat nick $id]] $ct(15)
    }
}

proc mc:pready {n uh h c t} {
    global mcs mc ct mcr mcc mce alrdsay

    if {$mc(phase) != 0} { return }
    set id [mc:makeid $n]

    if {![array exists mcr] || ![info exists mcr($id)]} {
        #mc:tsay [ms:dfl [mc:getstat nick $id]] $ct(15)
        return
    }
    if { $mce($id) == 1 } { return }
    set mce($id) 1
    mc:say [xformat3 $ct(readyo) [mc:getstat sex $id] [ms:dfl [mc:getstat nick $id]]]
    set alrdsay 0

    if { [array size mcr] >= $mc(limit) } {
        mc:checkready
    }

    cleartimers
    utimer $mc(killregsleep) { mc:killregsleep }
    mc:checkcomm
}

proc mc:punready {n uh h c t} {
    global mcs mc ct mcr mcc mce alrdsay completeready

    if { $mc(phase) != 0 } { return }
    if { $mc(gametype) == 2 } { return }

    set id [mc:makeid $n]

    if { [info exists completeready($id)] && $completeready($id) == 1 } { return }
    if {![array exists mcr] || ![info exists mcr($id)]} {
        #mc:tsay [ms:dfl [mc:getstat nick $id]] $ct(15)
        return
    }
    set alrdsay 0
    if {$mce($id)} {
        set mce($id) 0
        mc:say [xformat3 $ct(readyn) [mc:getstat sex $id] [ms:dfl [mc:getstat nick $id]]]
        cleartimers
        utimer $mc(killregsleep) { mc:killregsleep }
        mc:checkcomm
    }
}

proc mc:checkready {} {
    global mc mcs mcr mcc mce ct completeready

    if { $mc(phase) != 0 } { return }

    foreach id [array names mce] {
        if { $mce($id) == 0 } {
            return
        }
    }
    foreach id [array names mce] {
        set completeready($id) 1
    }

    mc:say $ct(readyf)
}

proc mc:killregsleep {} {
    global mcs mc ct mcr mcc mce alreadysleep

    set nicks ""
    set readyt 0

    foreach e [array names mce] {
        if {$mce($e) == 1} { incr readyt }
    }
    putlog "proc = [expr round($readyt * 1.0 / [array size mcr] * 100)]"
    if {[expr round($readyt * 1.0 / [array size mcr] * 100)] <= 65} { return }

    foreach e [array names mce] {
        if { $mce($e) != 1 } {
            set nicks [lappend nicks [mc:findonchan [ms:dfl [mc:getstat nick $e]]]]
            unset mcr($e)
            unset mce($e)
            mc:pushmode $mc(chan) -v [mc:findonchan [ms:dfl [mc:getstat nick $e]]]
            set alreadysleep($e) 1
        }
    }

    if { [array size mcr] == 0 } {
        unset mcr
        unset mce
        unset mcc
    }
    if { $nicks != "" } {
        set nicks [join $nicks "10, 04"]
        if { [llength $nicks] == 1 } {
            mc:say [xformat3 $ct(kregs) {} "" $nicks "" ""]
        } else {
            mc:say [xformat3 $ct(kregs) {} "" $nicks "" ""]
        }
        cleartimers
        mc:checkcomm
    }
}

proc mc:pclear {n uh h c t} {
    global mcs mc ct mcr mcc mce

    if { $mc(phase) != 0 } { return }

    if { [array exists mcc] } { unset mcc }
    if { [array exists mcr] } { unset mcr }
    if { [array exists mce] } { unset mce }
}

proc mc:checkcomm {} {
    global mcs mc ct mcr mcc mce alrdsay

    if { $mc(phase) != 0 } { return }

    if { ![array exists mce] || [array size mce] < 2 || [array size mcc] < 2 } {
        mc:say $ct(18a)
        return
    }

    foreach e [array names mce] {
        if { $mce($e) == 0 } {
#            mc:say $ct(18)
            utimer 30 { mc:checkcomm }
            return
        }
    }

    cleartimers
    set comm(0) 0
    set allcom 0
    foreach cc [array names mcr] {
        if { [info exist comm($mcr($cc))] } {
            incr comm($mcr($cc)) [mc:getstat level $cc]
            incr comm($mcr($cc)) [expr [mc:getstat remort $cc] * 8]
        } else {
            set comm($mcr($cc)) [mc:getstat level $cc]
            incr comm($mcr($cc)) [expr [mc:getstat remort $cc] * 8]
        }
        incr allcom [mc:getstat level $cc]
        incr allcom [expr [mc:getstat remort $cc] * 8]
    }
    foreach cc [array names comm] {
        if { [expr $comm($cc) - 1] > [expr $allcom - $comm($cc)] } {
            if { [mc:reg:getstat noname $cc] } {
              foreach id [array names mcr] { if {$mcr($id)==$cc} { break } }
              mc:say [xformat3 $ct(18c) [mc:getstat sex $id] [mc:getstat nick $id]]
            } else {
              mc:say [format $ct(18b) [mc:delcom [ms:dfl $mcc($cc)]]]
            }
            set secs 30
            if { $mc(gametype) == 2 || $mc(nocom) == 0 } {
                set secs 90
            }
            utimer $secs { mc:checkcomm }
            return
        }
    }

    utimer 3  { mc:checkvoices }
    utimer 30 { mc:pstart n uh h c t }
}

proc mc:pstart {n uh h c t} {
    global mcs mc ct mcr mcc mce min todo liv ghost killed param nnick prc hitten ripten countr countt runs
    global ts tl ti twis tv th ta tg te
    global startstr startdex startwis startint startcon starthp startmp
    global favor localfavor

    if { [array size mcr] < 2 || [array size mcc] < 2 } {
        mc:say $ct(18a)
        return
    }
    if { $mc(phase) != 0 } { return }

    if {[mc:istotal]} { mc:tot:startgame }

    if { [array exists liv] }        { unset liv        }
    if { [array exists ghost] }      { unset ghost      }
    if { [array exists killed] }     { unset killed     }
    if { [array exists localfavor] } { unset localfavor }
    cleartimers
    clearqueue all
    mc:say $ct(round1)

    #if {$mc(moderating) == 1 && ![mc:moderated]} {
    #    #pushmode $mc(chan) +m
    #    putquick "MODE $mc(chan) +m"
    #}
    mc:checkvoices

    set mc(phase) 1
    if {[array size mcr] > 10} {
        set mc(flags) ""
        putlog "setting slow mode"
    } else {
        set mc(flags) "F"
        putlog "setting fast mode"
    }
    set countr 0
    set countt [unixtime]

    mc:game:clearvar

    foreach e [array names mcr] {
      mc:setuser $e
      mc:game:initvar $e
    }
#    unset manaapply

    set hitten 0
    set ripten 0
    mc:start
    mc:checkend
}

proc mc:setuser {id} {
    global localfavor ts tl twis ti tv th ta tg te
    global startstr startdex startwis startint startcon starthp startmp
    global todo prc liv param nnick runs oldtodo

    set id [mc:makeid $id]

    set manaapply 0
    foreach tal [mc:getstat inv $id] {
        set tid [lindex $tal 0]
        set tcount [expr [llength $tal] - 1]
        if {$tcount <= 0} { continue }

        switch -- $tid {
            gab {
            ### 
                if {[mc:getstat prof $id] == "m" || [mc:getstat prof $id] == "p"} {
                    set manaapply [expr $manaapply + $tcount * [mc:wgettal $tid param1]]
                }
            }
        }
    }

    set localfavor($id) 0
    set ts($id) [mc:getstat str $id]
    set tl($id) [mc:getstat dex $id]
    set twis($id) [mc:getstat wis $id]
    set ti($id) [mc:getstat int $id]
    set tv($id) [mc:getstat con $id]
    set th($id) [mc:getmaxhp $id]
    set ta($id) [expr [mc:getmaxmp $id] + $manaapply]
    set tg($id) 0
    set te($id) 0
    set startstr($id) [mc:getstat rstr $id]
    set startdex($id) [mc:getstat rdex $id]
    set startwis($id) [mc:getstat rwis $id]
    set startint($id) [mc:getstat rint $id]
    set startcon($id) [mc:getstat rcon $id]
    set starthp($id) [mc:getrmaxhp $id]
    set startmp($id) [mc:getrmaxmp $id]
    set todo($id) ""
    set prc($id) [mc:getstat roundprc $id]
    set oldtodo($id) ""
    set liv($id) 1
    set param($id) ""
    set nnick($id) [mc:getstat nick $id]
    set runs($id) 0
}
