
proc mc:update:autodb {} {
  global mcs

  set updated 0
  set utmp    [mc:user:template]

  foreach id [array names mcs] {
    for {set i 0} {$i <= [llength $mcs($id)]} {incr i} {
      if { [llength [lindex $mcs($id) $i]] == [llength [lindex $utmp $i]] } { continue }
      set updated 1
      set newparam [lindex $mcs($id) $i]
      for {set ii [llength [lindex $mcs($id) $i]]} {$ii < [llength [lindex $utmp $i]]} {incr ii} {
        lappend newparam [lindex [lindex $utmp $i] $ii]
      }
      set mcs($id) [lreplace $mcs($id) $i $i $newparam]
    }
  }
  if { $updated } {
    putlog "User-DB was updated."
  }
}


proc mc:update:2.1.1to2.1.2 {} {
  global mcs

  foreach id [array names mcs] {
    set eq    [mc:getstat eq $id]
    set money [mc:getstat gold $id]
    foreach item $eq {
      set nn [lindex $item 1]
      set price [mc:wget $nn price $id]
      if {[mc:wfound $nn remort $id]=="1"} {
        set price [expr round(($price + [mc:specprice $id [mc:wgetspec spa gold]  [mc:wgetspec spa modgold]  $price]) * 0.55)]
      } elseif {$price >= 1000} { set price [expr round($price * 0.55)] }
      set money [expr $money + $price]
    }
    mc:setstat eq $id "{waa 0 1 a {}}"
    mc:setstat gold $id $money
    mc:setstat eset $id 0
    mc:setstat wield $id "0 -"
  }
  mc:say "4   () !"
  return 1
}

proc mc:update:2.1.2to2.1.3 {} {
   global mcs

   set i 0
   foreach id [array names mcs] {
     regsub -all  $id !8 id2
     if {$id == $id2} { continue }
     set mcs($id2) $mcs($id)
     unset mcs($id)
     incr i
   }
   putlog "converted $i nicks."
   return 1
}

proc mc:update:2.1.3to2.2.0 {} {
  global prof

  foreach id [mc:getalluser] {
    if { [mc:getstat prof $id] != "l" } { continue }

    set bonus 0
    foreach sk [mc:getstat skill $id] {
      if { [lindex $sk 0] != "-" } {
        incr bonus [lindex $sk 1]
      }
    }
    mc:setstat prof  $id "w"
    mc:setstat skill $id [lindex $prof([mc:getstat prof $id]) 15]
    mc:setstat bonus $id [expr [mc:getstat bonus $id] + $bonus]
    mc:setstat skp   $id [expr ([mc:getstat level $id] - 1) * 3]
  }
  mc:say "5 '45' ."
  mc:findmasters
  mc:save
  return 1
}

proc mc:update:2.2.0to2.2.1 {} {
  putlog "Droping plat-item..."
  set dnick ""
  set plat  "aao hag gag faf"
  foreach id [mc:getalluser] {
    set neweq ""
    set gold   0
    set droped 0
    foreach item [mc:getstat eq $id] {
      if { [lsearch -exact $plat [lindex $item 0]] != -1} {
        set droped 1
        set gold [expr $gold + [mc:wget [lindex $item 1] price $id]]
      } {
        lappend neweq $item
      }
    }
    if { $droped } {
      lappend dnick $id
      mc:setstat eq   $id $neweq
      mc:setstat gold $id [expr [mc:getstat gold $id] + $gold]
    }
  }
  putlog "Droped for nicks: $dnick"
  putlog "Drop plat-item done."
  mc:say "4    ."
  mc:save
  return 1
}

proc mc:update:2.2.1to2.3.0 {} {
  putlog "Replace magic 1ma to 1pc for all chars..."
  set num 0
  foreach id [mc:getalluser] {
    set newmagic ""
    foreach mrec [mc:getstat magic $id] {
      if { [lindex $mrec 0] == "1mc" } { set mrec [lreplace $mrec 0 0 "1pc"]; incr num }
      lappend newmagic $mrec
    }
    mc:setstat magic $id $newmagic
  }
  putlog "Replaced $num spells."
  mc:save
  return 1
}

proc mc:update:2.2.1to2.3.0two {} {
    putlog "Replace magic for mages and priests..."

    foreach id [mc:getalluser] {
        set newmagic ""
        foreach mrec [mc:getstat magic $id] {
            set newspell 0

            if { [lindex $mrec 0] == "4mc" } { set mrec [lreplace $mrec 0 0 "5me"]; set newspell 5 }
            if { [lindex $mrec 0] == "4pb" } { set mrec [lreplace $mrec 0 0 "5pc"]; set newspell 5 }
            if { [lindex $mrec 0] == "4pe" } { set mrec [lreplace $mrec 0 0 "3pd"]; set newspell 3 }
            if { [lindex $mrec 0] == "5pd" } { set mrec [lreplace $mrec 0 0 "4pe"]; set newspell 4 }
            if { [lindex $mrec 0] == "3pa" } { set mrec [lreplace $mrec 0 0 "4pb"]; set newspell 4 }
            if { [lindex $mrec 0] == "5pc" } { set mrec [lreplace $mrec 0 0 "3pc"]; set newspell 3 }
            if { [lindex $mrec 0] == "2pe" } { set mrec [lreplace $mrec 0 0 "3pa"]; set newspell 3 }
            if { [lindex $mrec 0] == "1pd" } { set mrec [lreplace $mrec 0 0 "2pe"]; set newspell 2 }
            if { [lindex $mrec 0] == "1pf" } { set mrec [lreplace $mrec 0 0 "1pd"]; set newspell 1 }

            if { $newspell > 0 && [expr ($newspell - 1) * 2 + 1] > [mc:getstat level $id] } {
                mc:setstat bonus $id [expr [mc:getstat bonus $id] + [lindex $mrec 1]]
                continue
            }

            lappend newmagic $mrec
        }
        mc:setstat magic $id $newmagic
    }

#    mc:save
    return 1
}

proc mc:update:2.4.0to2.4.1 {} {
    global mcs

    foreach id [array names mcs] {
        set money [mc:getstat gold $id]
        foreach item [mc:getstat eq $id] {
            set nn [lindex $item 1]
            set price [mc:wfound $nn price $id]
            set money [expr $money + $price]
        }
        putlog "Money for $id : $money"
        mc:setstat eq $id "{waa 0 1 a {}}"
        mc:setstat gold $id $money
        mc:setstat eset $id 0
        mc:setstat wield $id "0 -"
    }

    return 1
}

proc mc:update:run {h i t} {
  set t [split $t]
  mc:dcclogcmd $h update $t
  if {[llength $t] != 2} {
    putidx $i "Usage: update <from version> <to version>\r"
    return
  }

  set frver [lindex $t 0]
  set tover [lindex $t 1]

  if {![regexp \[0-9\]\.\[0-9\]\.\[0-9\] $frver]} {
    putidx $i "\(update\) $frver is invalid version number.\r"
    return
  }
  if {![regexp \[0-9\]\.\[0-9\]\.\[0-9\] $tover]} {
    putidx $i "\(update\) $tover is invalid version number.\r"
    return
  }

  if {"[info procs mc:update:${frver}to${tover}]" == ""} {
    putidx $i "\(update\) procedure to update from $frver to $tover is not found.\r"
    return
  }

  putidx $i "\(update\) Run update proc from v$frver to v${tover}..."
  if { [mc:update:${frver}to${tover}] } {
    mc:config:setver $tover
  }
  putidx $i "\(update\) Done."
}

proc mc:update:init {} {
  global mc col scriptversion

  set banner 0
  if { $mc(ver) == 0 } {
    mc:config:setver $scriptversion
  } elseif {$mc(ver) != $scriptversion} {
    set fail 1
    set tmpv [split $mc(ver) .]
    set procs [info commands "mc:update:*to*"]
    if { $procs != "" } {
      foreach pn $procs {
        set pn [split [lindex [split $pn ":"] 2] "to"]
        set pv [split [lindex $pn 0] .]
        if { ![isnumber [lindex $pv 0]] || ![isnumber [lindex $pv 1]] || ![isnumber [lindex $pv 2]] } { continue }
        if { [lindex $pv 0] < [lindex $tmpv 0] || [lindex $pv 1] < [lindex $tmpv 1] || [lindex $pv 2] < [lindex $tmpv 2] } { continue }
        if { !$banner } {
           putlog "$col(red)!Warning! Need update. Current ver $mc(ver), script ver $scriptversion"
           set banner 1
        }
        putlog "$col(red)Use: .update [lindex $pn 0] [lindex $pn end]"
        set fail 0
      }
    }
    if { $fail } {
      putlog "$col(red)WOW! Your script updated from v$mc(ver) to v${scriptversion}!!!"
      mc:config:setver $scriptversion
    } {
      putlog "$col(red)This commands complite update your DB."
    }
  }
  mc:update:autodb
}
